﻿using System;
using System.Collections.Generic;
using System.Web.Mvc;
using Xenta.Utils;

namespace Xenta.Web.Controllers
{
    public sealed class AdvController : ExtController
    {
        [ChildActionOnly]
        public ActionResult _Index()
        {
            var m = Svc.ProcessOperation("SearchPublications", new
            {
                LanguageID = JDM.Int32(Svc.Localization.Language.EntityID),
                PublishedTo = DateTime.UtcNow,
                FlagMask = "Active,Advertisement",
                SortBy = new[] 
                {
                    "PublishedOn"
                },
                SortDir = "Descending"
            }, new
            {
                DisclosureLevel = "Entire",
                DisclosureOptions = new Dictionary<String, String>
                {
                    { "TranslatedTo", JDM.String(Svc.Localization.Language.Code) }
                }.Unload()
            }).Items;
            return PartialView(m);
        }
    }
}
