﻿using System;
using System.Collections.Generic;
using NHibernate.Mapping.ByCode;
using Xenta.Enums;

namespace Xenta.Entities
{
    /// <summary>
    /// Represents the account comment entity.
    /// </summary>
    /// <remarks><pre>
    /// The entity regarding the disclosure level.
    /// 
    /// + Entire
    ///  + Extended
    ///  | - Text
    ///   + Base
    ///    | - HolderID
    ///    | - Account(of the Keys level)
    ///    | - Title
    ///    | - UpdatedOn
    ///    | - CreatedOn
    ///    + Keys
    ///     + Primary
    ///      | - EntityID
    /// 
    /// Note: upper level includes lower level.
    /// </pre></remarks>
    public class AccountCommentEntity : CommentEntity
    {
    }

    /// <summary>
    /// The entity NHibernate mapper.
    /// </summary>
    public class AccountCommentMapping : SubEntityMapping<AccountCommentEntity>
    {
        #region Constants

        /// <summary>
        /// The value to be used as the generic attribute entity discriminator.
        /// </summary>
        public const string DISCRIMINATOR_VALUE = "ACCOUNT";

        #endregion

        #region Ctors

        /// <summary>
        /// Initializes a new class instance.
        /// </summary>
        public AccountCommentMapping()
        {
            DiscriminatorValue(DISCRIMINATOR_VALUE);
        }

        #endregion
    }
}
