﻿using Xenta.Entities;

namespace Xenta.Plugins
{
    /// <summary>
    /// Exposes the message sender interface.
    /// </summary>
    public interface IMessageSender : IPlugin
    {
        #region Methods

        /// <summary>
        /// Sends the message.
        /// </summary>
        /// <param name="message">The message entity.</param>
        /// <returns>
        /// The result of sending: 
        /// less than zero - message not sent, do not try again;
        /// zero - message not sent, try again later;
        /// greater than zero - message sent.
        /// </returns>
        int Send(MessageEntity message);

        #endregion
    }
}
