﻿using System;

namespace Xenta.Enums
{
    /// <summary>
    /// Defines the attribute flags.
    /// </summary>
    [Flags]
    public enum LookupAttributeFlags
    {
        /// <summary>
        /// Indicates no flags.
        /// </summary>
        None = 0x00000000,

        #region S

        /// <summary>
        /// Indicates that an entity is active.
        /// </summary>
        Active = 0x00000001,

        #endregion

        #region G1

        /// <summary>
        /// Indicates that an attribute can be applied to an any entity.
        /// </summary>
        Common = 0x00000010,

        /// <summary>
        /// Indicates that an attribute can be applied to a catalog supplier.
        /// </summary>
        CatalogSupplier = 0x00000020,

        /// <summary>
        /// Indicates that an attribute can be applied to a catalog item.
        /// </summary>
        CatalogItem = 0x00000040,

        /// <summary>
        /// Indicates that an attribute can be applied to a publication.
        /// </summary>
        Publication = 0x00000080,

        #endregion

        #region O

        /// <summary>
        /// Indicates that attribute can be used for search.
        /// </summary>
        AllowedForSearch = 0x00010000,

        #endregion
    }
}
