﻿using System;

namespace Xenta.Enums
{
    /// <summary>
    /// Defines the forum access rights.
    /// </summary>
    [Flags]
    public enum ForumAccessRights : byte
    {
        /// <summary>
        /// Indicates the read-only access.
        /// </summary>
        ReadOnly = 0x01,

        /// <summary>
        /// Indicates the read and write access.
        /// </summary>
        ReadWrite = ReadOnly | 0x02,

        /// <summary>
        /// Indicates the read, write and moderate access.
        /// </summary>
        Moderate = ReadWrite | 0x04
    }
}
