﻿namespace Xenta.Entities
{
    /// <summary>
    /// Represents the payment attribute entity.
    /// </summary>
    /// <remarks>
    /// The discriminator is "PAYMENT".
    /// </remarks>
    /// <remarks><pre>
    /// The dynamic object regarding the disclosure level.
    /// 
    /// + Entire
    ///  + Extended
    ///   + Base
    ///    | - Value
    ///    | - UpdatedOn
    ///    | - CreatedOn
    ///    + Keys
    ///     | - HolderID
    ///     | - Key
    ///     + Primary
    ///      | - EntityID
    /// 
    /// Note: upper level includes lower level.
    /// </pre></remarks>
    public class PaymentAttributeEntity : GenericAttributeEntity
    {
    }

    /// <summary>
    /// The entity NHibernate mapper.
    /// </summary>
    public class PaymentAttributeMapping : SubEntityMapping<PaymentAttributeEntity>
    {
        #region Constants

        /// <summary>
        /// The value to be used as the generic attribute entity discriminator.
        /// </summary>
        public const string DISCRIMINATOR = "PAYMENT";

        #endregion

        #region Ctors

        /// <summary>
        /// Initializes a new class instance.
        /// </summary>
        public PaymentAttributeMapping()
        {
            DiscriminatorValue(DISCRIMINATOR);
        }

        #endregion
    }
}
