﻿using System;

namespace Xenta.Enums
{
    /// <summary>
    /// Defines the volume discount sales rule flags.
    /// </summary>
    [Flags]
    public enum VolumeDiscountRuleFlags
    {
        /// <summary>
        /// Indicates no flags.
        /// </summary>
        None = 0x00000000,

        #region G1

        /// <summary>
        /// The amount is to be handled as a value amount.
        /// </summary>
        Value = 0x00000010,

        /// <summary>
        /// The amount is to be handled as a percent.
        /// </summary>
        Percent = 0x00000020,

        #endregion

        #region G2

        /// <summary>
        /// The discount is to be applied based on the quantity.
        /// </summary>
        Quantity = 0x00000400,

        /// <summary>
        /// The discount is to be applied based on the total.
        /// </summary>
        Total = 0x00000800

        #endregion
    }
}
