﻿namespace Xenta.Enums
{
    /// <summary>
    /// Defines the disclosure level.
    /// </summary>
    public enum DisclosureLevel : byte
    {
        /// <summary>
        /// Includes the primary information
        /// (e.g. entity identifier).
        /// </summary>
        Primary = 1,

        /// <summary>
        /// Includes the information of Primary level
        /// and an additional key information.
        /// </summary>
        Keys = 2,

        /// <summary>
        /// Includes infromation of Keys level
        /// and the base information.
        /// </summary>
        Base = 3,

        /// <summary>
        /// Includes infromation of Base level
        /// and the extended information.
        /// </summary>
        Extended = 4,

        /// <summary>
        /// Includes infromation of Extended level
        /// and an additional extra information.
        /// </summary>
        Entire = 5
    }
}
