﻿using System;
using System.Collections.Generic;
using Xenta.Enums;

namespace Xenta
{
    /// <summary>
    /// Exposes the disclosable object interface.
    /// </summary>
    public interface IDisclosable
    {
        /// <summary>
        /// Discloses the object.
        /// </summary>
        /// <param name="level">The disclosure level.</param>
        /// <param name="options">The disclosure options.</param>
        /// <returns>The object.</returns>
        object Disclose(DisclosureLevel level, IDictionary<String, String> options);
    }
}
