﻿using System.Security.Principal;

namespace Xenta
{
    /// <summary>
    /// Exposes the environment interface.
    /// </summary>
    /// <remarks>
    /// The environment interface allows to obtain 
    /// an information about execution environment.
    /// This interface is being implemented by the 
    /// host-application.
    /// </remarks>
    public interface IEnvironment
    {
        #region Properties

        /// <summary>
        /// Gets the working directory.
        /// </summary>
        string WorkingDir
        {
            get;
        }

        /// <summary>
        /// Gets the data directory.
        /// </summary>
        string DataDir
        {
            get;
        }

        /// <summary>
        /// Gets the binary directory.
        /// </summary>
        string BinDir
        {
            get;
        }

        /// <summary>
        /// Gets the working identity.
        /// </summary>
        WindowsIdentity WorkingIdentity
        {
            get;
        }

        #endregion
    }
}
